#!r6rs
;;; FILE "implementation-dependent.sls"
;;; IMPLEMENTS Ikarus Scheme specific compatability functions
;;; AUTHOR Ken [dot] Dickey [at] Whidbey [dot] Com

;;;COPYRIGHT (c) 2008 by Kenneth A Dickey. All rights reserved.
;;;
;;;Permission is hereby granted, free of charge, to any person
;;;obtaining a copy of this software and associated documentation
;;;files (the "Software"), to deal in the Software without
;;;restriction, including without limitation the rights to use,
;;;copy, modify, merge, publish, distribute, sublicense, and/or
;;;sell copies of the Software, and to permit persons to whom
;;;the Software is furnished to do so, subject to the following
;;;conditions:
;;;
;;;The above copyright notice and this permission notice shall
;;;be included in all copies or substantial portions of the Software.
;;;
;;;THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND,
;;;EXPRESS OR IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES
;;;OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
;;;NONINFRINGEMENT. IN NO EVENT SHALL THE AUTHORS OR COPYRIGHT
;;;HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER LIABILITY,
;;;WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING
;;;FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR
;;;OTHER DEALINGS IN THE SOFTWARE.

;; USAGE: copy or link to 1st dir in IKARUS_LIBRARY_PATH with name
;; "implementation-dependent.sls"

(library (implementation-dependent)
  (export
   pretty-print
   write-with-shared-structure
   dont-print
   ;; from srfi-6 "basic string ports"
   open-output-string get-output-string
   )
  (import
   (rnrs)
   (only (ikarus) pretty-print print-graph)
   (only (ikarus) open-output-string get-output-string)
   )

(define dont-print (if (eq? #t #f) 1))

(define write-with-shared-structure print-graph)

)